//------------------------------------------------------------------------------
// <auto-generated>
//      Generated by NativeAssist version 1.0.0.0 with Split Generator.
//      Do not modify this file unless necessary.
// </auto-generated>
//------------------------------------------------------------------------------

namespace NativeFx.Interop;

using System;
using GTA.Native;
using GTA;
using GTA.Math;

public static partial class Natives 
{
public static class Shapetest {
/// <summary>
/// Asynchronously starts a line-of-sight (raycast) world probe shape test.<br /><br />Use the handle with 0x3D87450E15D98694 or 0x65287525D951F6BE until it returns 0 or 2.<br /><br />p8 is a bit mask with bits 1, 2 and/or 4, relating to collider types; 4 should usually be used.
/// </summary>
/// <remarks>
/// <para>
/// <b>In Namespace:</b> Shapetest<br />
/// <b>From Build:</b> 323<br />
/// <b>Native ID:</b> 0x7EE9F5D83DD4F90E<br />
/// </para>
/// </remarks>
public static int StartShapeTestLosProbe(float x1, float y1, float z1, float x2, float y2, float z2, int flags, int /* Entity */ entity, int p8){
return Function.Call<int>((Hash)0x7EE9F5D83DD4F90EuL, x1, y1, z1, x2, y2, z2, flags, entity, p8);
}

/// <summary>
/// Does the same as 0x7EE9F5D83DD4F90E, except blocking until the shape test completes.
/// </summary>
/// <remarks>
/// <para>
/// <b>In Namespace:</b> Shapetest<br />
/// <b>From Build:</b> 323<br />
/// <b>Native ID:</b> 0x377906D8A31E5586<br />
/// </para>
/// </remarks>
public static int StartExpensiveSynchronousShapeTestLosProbe(float x1, float y1, float z1, float x2, float y2, float z2, int flags, int /* Entity */ entity, int p8){
return Function.Call<int>((Hash)0x377906D8A31E5586uL, x1, y1, z1, x2, y2, z2, flags, entity, p8);
}

/// <summary>
/// <i>No description available.</i>
/// </summary>
/// <remarks>
/// <para>
/// <b>In Namespace:</b> Shapetest<br />
/// <b>From Build:</b> 323<br />
/// <b>Native ID:</b> 0x052837721A854EC7<br />
/// </para>
/// </remarks>
public static int StartShapeTestBoundingBox(int /* Entity */ entity, int flags1, int flags2){
return Function.Call<int>((Hash)0x052837721A854EC7uL, entity, flags1, flags2);
}

/// <summary>
/// <i>No description available.</i>
/// </summary>
/// <remarks>
/// <para>
/// <b>In Namespace:</b> Shapetest<br />
/// <b>From Build:</b> 323<br />
/// <b>Native ID:</b> 0xFE466162C4401D18<br />There were parameter(s) that was labeled as <b>Any</b>, and these had been written as <c>int</c> by generator.
/// </para>
/// </remarks>
public static int StartShapeTestBox(float x, float y, float z, float dimX, float dimY, float dimZ, float rotX, float rotY, float rotZ, int /* bug: Any */ p9, int flags, int /* Entity */ entity, int /* bug: Any */ p12){
return Function.Call<int>((Hash)0xFE466162C4401D18uL, x, y, z, dimX, dimY, dimZ, rotX, rotY, rotZ, p9, flags, entity, p12);
}

/// <summary>
/// <i>No description available.</i>
/// </summary>
/// <remarks>
/// <para>
/// <b>In Namespace:</b> Shapetest<br />
/// <b>From Build:</b> 323<br />
/// <b>Native ID:</b> 0x37181417CE7C8900<br />
/// </para>
/// </remarks>
public static int StartShapeTestBound(int /* Entity */ entity, int flags1, int flags2){
return Function.Call<int>((Hash)0x37181417CE7C8900uL, entity, flags1, flags2);
}

/// <summary>
/// Raycast from point to point, where the ray has a radius. <br /><br />flags:<br />vehicles=10<br />peds =12<br /><br />Iterating through flags yields many ped / vehicle/ object combinations<br /><br />p9 = 7, but no idea what it does<br /><br />Entity is an entity to ignore
/// </summary>
/// <remarks>
/// <para>
/// <b>In Namespace:</b> Shapetest<br />
/// <b>From Build:</b> 323<br />
/// <b>Native ID:</b> 0x28579D1B8F8AAC80<br />
/// </para>
/// </remarks>
public static int StartShapeTestCapsule(float x1, float y1, float z1, float x2, float y2, float z2, float radius, int flags, int /* Entity */ entity, int p9){
return Function.Call<int>((Hash)0x28579D1B8F8AAC80uL, x1, y1, z1, x2, y2, z2, radius, flags, entity, p9);
}

/// <summary>
/// <i>No description available.</i>
/// </summary>
/// <remarks>
/// <para>
/// <b>In Namespace:</b> Shapetest<br />
/// <b>From Build:</b> 323<br />
/// <b>Native ID:</b> 0xE6AC6C45FBE83004<br />There were parameter(s) that was labeled as <b>Any</b>, and these had been written as <c>int</c> by generator.
/// </para>
/// </remarks>
public static int StartShapeTestSweptSphere(float x1, float y1, float z1, float x2, float y2, float z2, float radius, int flags, int /* Entity */ entity, int /* bug: Any */ p9){
return Function.Call<int>((Hash)0xE6AC6C45FBE83004uL, x1, y1, z1, x2, y2, z2, radius, flags, entity, p9);
}

/// <summary>
/// Returns a ShapeTest handle that can be used with GET_SHAPE_TEST_RESULT.<br /><br />In its only usage in game scripts its called with flag set to 511, entity to player_ped_id and flag2 set to 7
/// </summary>
/// <remarks>
/// <para>
/// <b>In Namespace:</b> Shapetest<br />
/// <b>From Build:</b> 323<br />
/// <b>Native ID:</b> 0xFF6BE494C7987F34<br />
/// </para>
/// </remarks>
public static int StartShapeTestMouseCursorLosProbe(ref Vector3 pVec1, ref Vector3 pVec2, int flag, int /* Entity */ entity, int flag2){
var nativeAssistPointerVar0 = pVec1;
var nativeAssistPointerVar1 = pVec2;
int retVal;
unsafe {
retVal = Function.Call<int>((Hash)0xFF6BE494C7987F34uL, &nativeAssistPointerVar0, &nativeAssistPointerVar1, flag, entity, flag2);
}
pVec1 = nativeAssistPointerVar0;
pVec2 = nativeAssistPointerVar1;
return retVal;
}

/// <summary>
/// Returns the result of a shape test: 0 if the handle is invalid, 1 if the shape test is still pending, or 2 if the shape test has completed, and the handle should be invalidated.<br /><br />When used with an asynchronous shape test, this native should be looped until returning 0 or 2, after which the handle is invalidated.
/// </summary>
/// <remarks>
/// <para>
/// <b>In Namespace:</b> Shapetest<br />
/// <b>From Build:</b> 323<br />
/// <b>Native ID:</b> 0x3D87450E15D98694<br />
/// </para>
/// </remarks>
public static int GetShapeTestResult(int shapeTestHandle, ref bool hit, ref Vector3 endCoords, ref Vector3 surfaceNormal, ref int /* Entity* */ entityHit){
var nativeAssistPointerVar0 = hit;
var nativeAssistPointerVar1 = endCoords;
var nativeAssistPointerVar2 = surfaceNormal;
var nativeAssistPointerVar3 = entityHit;
int retVal;
unsafe {
retVal = Function.Call<int>((Hash)0x3D87450E15D98694uL, shapeTestHandle, &nativeAssistPointerVar0, &nativeAssistPointerVar1, &nativeAssistPointerVar2, &nativeAssistPointerVar3);
}
hit = nativeAssistPointerVar0;
endCoords = nativeAssistPointerVar1;
surfaceNormal = nativeAssistPointerVar2;
entityHit = nativeAssistPointerVar3;
return retVal;
}

/// <summary>
/// Returns the result of a shape test, also returning the material of any touched surface.<br /><br />When used with an asynchronous shape test, this native should be looped until returning 0 or 2, after which the handle is invalidated.<br /><br />Unless the return value is 2, the other return values are undefined.
/// </summary>
/// <remarks>
/// <para>
/// <b>In Namespace:</b> Shapetest<br />
/// <b>From Build:</b> 323<br />
/// <b>Native ID:</b> 0x65287525D951F6BE<br />
/// </para>
/// </remarks>
public static int GetShapeTestResultIncludingMaterial(int shapeTestHandle, ref bool hit, ref Vector3 endCoords, ref Vector3 surfaceNormal, ref uint materialHash, ref int /* Entity* */ entityHit){
var nativeAssistPointerVar0 = hit;
var nativeAssistPointerVar1 = endCoords;
var nativeAssistPointerVar2 = surfaceNormal;
var nativeAssistPointerVar3 = materialHash;
var nativeAssistPointerVar4 = entityHit;
int retVal;
unsafe {
retVal = Function.Call<int>((Hash)0x65287525D951F6BEuL, shapeTestHandle, &nativeAssistPointerVar0, &nativeAssistPointerVar1, &nativeAssistPointerVar2, &nativeAssistPointerVar3, &nativeAssistPointerVar4);
}
hit = nativeAssistPointerVar0;
endCoords = nativeAssistPointerVar1;
surfaceNormal = nativeAssistPointerVar2;
materialHash = nativeAssistPointerVar3;
entityHit = nativeAssistPointerVar4;
return retVal;
}

/// <summary>
/// Invalidates the entity handle passed by removing the fwScriptGuid from the entity. This should be used when receiving an ambient entity from shape testing natives, but can also be used for other natives returning an &apos;irrelevant&apos; entity handle.
/// </summary>
/// <remarks>
/// <para>
/// <b>In Namespace:</b> Shapetest<br />
/// <b>From Build:</b> 323<br />
/// <b>Native ID:</b> 0x2B3334BCA57CD799<br />
/// </para>
/// </remarks>
public static void ReleaseScriptGuidFromEntity(int /* Entity */ entityHit){
Function.Call((Hash)0x2B3334BCA57CD799uL, entityHit);
}

}}
